Attribute VB_Name = "MdlGridExtras"
Option Explicit
Private Declare Function GdipFillEllipseI Lib "GdiPlus.dll" (ByVal mGraphics As Long, ByVal mBrush As Long, ByVal mX As Long, ByVal mY As Long, ByVal mWidth As Long, ByVal mHeight As Long) As Long
Private Declare Function GdipCreateSolidFill Lib "GdiPlus.dll" (ByVal mColor As Long, ByRef mBrush As Long) As Long
Private Declare Function GdipDeleteBrush Lib "GdiPlus.dll" (ByVal mBrush As Long) As Long
Private Declare Function GdipCreatePath Lib "GdiPlus.dll" (ByRef mBrushMode As Long, ByRef mPath As Long) As Long
Private Declare Function GdipDeletePath Lib "GdiPlus.dll" (ByVal mPath As Long) As Long
Private Declare Function GdipDrawPath Lib "GdiPlus.dll" (ByVal mGraphics As Long, ByVal mPen As Long, ByVal mPath As Long) As Long
Private Declare Function GdipFillPath Lib "GdiPlus.dll" (ByVal mGraphics As Long, ByVal mBrush As Long, ByVal mPath As Long) As Long
Private Declare Function GdipDrawLinesI Lib "GdiPlus.dll" (ByVal mGraphics As Long, ByVal mPen As Long, ByRef mPoints As POINTL, ByVal mCount As Long) As Long
Private Declare Function GdipDeletePen Lib "GdiPlus.dll" (ByVal mPen As Long) As Long
Private Declare Function GdipCreatePen1 Lib "GdiPlus.dll" (ByVal mColor As Long, ByVal mWidth As Single, ByVal mUnit As Long, ByRef mPen As Long) As Long
Private Declare Sub GdiplusShutdown Lib "gdiplus" (ByVal Token As Long)
Private Declare Function GdiplusStartup Lib "gdiplus" (Token As Long, inputbuf As GDIPlusStartupInput, Optional ByVal outputbuf As Long = 0) As Long
Private Declare Function GdipCreateFromHDC Lib "gdiplus" (ByVal hdc As Long, hGraphics As Long) As Long
Private Declare Function GdipDeleteGraphics Lib "gdiplus" (ByVal hGraphics As Long) As Long
Private Declare Function GdipSetSmoothingMode Lib "gdiplus" (ByVal graphics As Long, ByVal SmoothingMd As Long) As Long
Private Declare Function GetSysColor Lib "user32.dll" (ByVal nIndex As Long) As Long
Private Declare Function GdipSetClipRectI Lib "GdiPlus.dll" (ByVal mGraphics As Long, ByVal mX As Long, ByVal mY As Long, ByVal mWidth As Long, ByVal mHeight As Long, ByVal mCombineMode As Long) As Long
Private Declare Function GdipResetClip Lib "GdiPlus.dll" (ByVal mGraphics As Long) As Long
Private Declare Function GdipAddPathArcI Lib "GdiPlus.dll" (ByVal mPath As Long, ByVal mX As Long, ByVal mY As Long, ByVal mWidth As Long, ByVal mHeight As Long, ByVal mStartAngle As Single, ByVal mSweepAngle As Single) As Long
Private Declare Function GdipClosePathFigure Lib "GdiPlus.dll" (ByVal mPath As Long) As Long
Private Declare Function DrawText Lib "user32.dll" Alias "DrawTextW" (ByVal hdc As Long, ByVal lpStr As Long, ByVal nCount As Long, ByRef lpRect As Rect, ByVal wFormat As Long) As Long
Private Declare Function SelectObject Lib "gdi32.dll" (ByVal hdc As Long, ByVal hObject As Long) As Long
Private Declare Function SetTextColor Lib "gdi32.dll" (ByVal hdc As Long, ByVal crColor As Long) As Long
Public Declare Function GetDC Lib "user32.dll" (ByVal hwnd As Long) As Long
Public Declare Function ReleaseDC Lib "user32.dll" (ByVal hwnd As Long, ByVal hdc As Long) As Long
Private Declare Function FillRect Lib "user32" (ByVal hdc As Long, lpRect As Rect, ByVal hBrush As Long) As Long
Private Declare Function CreateSolidBrush Lib "GDI32" (ByVal crColor As Long) As Long
Private Declare Function DeleteObject Lib "GDI32" (ByVal hObject As Long) As Long

Private Type GDIPlusStartupInput
    GdiPlusVersion              As Long
    DebugEventCallback          As Long
    SuppressBackgroundThread    As Long
    SuppressExternalCodecs      As Long
End Type

Private Type POINTL
    X As Long
    Y As Long
End Type

Public Type Rect
    Left As Long
    Top As Long
    Right As Long
    Bottom As Long
End Type
Private Const DT_LEFT As Long = &H0
Private Const DT_VCENTER As Long = &H4
Private Const DT_SINGLELINE As Long = &H20
Private Const DT_CALCRECT As Long = &H400

Private Const SmoothingModeAntiAlias    As Long = 4

Private GdipToken As Long

Public Sub FillRectangle(hdc As Long, Left As Long, Top As Long, Right As Long, Bottom As Long, ByVal Color As OLE_COLOR)
    Dim hBrush As Long
    Dim Rect As Rect
    With Rect
        .Left = Left
        .Top = Top
        .Right = Right
        .Bottom = Bottom
    End With
    If (Color And &H80000000) Then Color = GetSysColor(Color And &HFF&)
    hBrush = CreateSolidBrush(Color)
    FillRect hdc, Rect, hBrush
    Call DeleteObject(hBrush)
End Sub

Public Function DrawRank(ByVal hdc As Long, ByVal Value As Double, _
                        ByVal Left As Long, ByVal Top As Long, _
                        ByVal Rigth As Long, ByVal Bootom As Long, _
                        ByVal BackColor As Long, ByVal ForeColor As Long, _
                        ByVal Font As iFont, ByVal ChrCode As Long, _
                        ByVal CalcWidth As Boolean) As Long
                        
                        
    'Dim oFont As StdFont
    'Dim iFont As iFont
    Dim sChr As String
    Dim R As Rect
    Dim PrevFont As Long
    Dim PrevColor As Long
    Dim i  As Long
    
    If (BackColor And &H80000000) Then BackColor = GetSysColor(BackColor And &HFF&)
    If (ForeColor And &H80000000) Then ForeColor = GetSysColor(ForeColor And &HFF&)
    
    R.Left = Left
    R.Top = Top
    R.Right = Rigth
    R.Bottom = Bootom
    
    'sChr = String(5, ChrW2(&HE249))
    For i = 0 To 4
        sChr = sChr & ChrW2(ChrCode) & Space(1)
    Next
    
'    Set oFont = New StdFont
'    oFont.Name = "Segoe MDL2 Assets"
'    oFont.Size = (Bootom - Top) / 2
'    Set iFont = oFont
    
    PrevFont = SelectObject(hdc, Font.hFont)
    
    
    If CalcWidth Then
        sChr = VBA.Left$(sChr, Len(sChr) - 1)
        DrawText hdc, StrPtr(sChr), -1, R, DT_LEFT Or DT_SINGLELINE Or DT_VCENTER Or DT_CALCRECT
        DrawRank = R.Right - R.Left
    Else
        PrevColor = SetTextColor(hdc, BackColor)
        DrawText hdc, StrPtr(sChr), -1, R, DT_LEFT Or DT_SINGLELINE Or DT_VCENTER
        Call SetTextColor(hdc, ForeColor)
        'sChr = String(Value, ChrW2(&HE249))
        sChr = vbNullString
        For i = 0 To Value - 1
            sChr = sChr & ChrW2(ChrCode) & Space(1)
        Next
        
        DrawText hdc, StrPtr(sChr), -1, R, DT_LEFT Or DT_SINGLELINE Or DT_VCENTER
        Call SetTextColor(hdc, PrevColor)
    End If
    
    SelectObject hdc, PrevFont
End Function

Public Sub DrawProgress(ByVal hdc As Long, ByVal Value As Double, _
                        ByVal Left As Long, ByVal Top As Long, _
                        ByVal Width As Long, ByVal Height As Long, _
                        ByVal BackColor As Long, ByVal ForeColor As Long, _
                        ByVal BorderColor As Long, ByVal BorderWidth As Long, _
                        ByVal Radius As Long)
                        
    Dim hPath As Long, hPen As Long, hBrush As Long, hGraphics As Long
    Dim lPercent As Long
    
    GdipCreateFromHDC hdc, hGraphics
    GdipSetSmoothingMode hGraphics, SmoothingModeAntiAlias
    
    hPath = RoundRectPath(Left, Top, Width, Height, Radius)
    GdipCreateSolidFill RGBtoARGB(ForeColor, 100), hBrush
    GdipFillPath hGraphics, hBrush, hPath
    GdipDeleteBrush hBrush

    lPercent = Value * Width / 100
    GdipSetClipRectI hGraphics, Left, Top, lPercent, Height, &H3   'CombineModeXor
    GdipCreateSolidFill RGBtoARGB(BackColor, 100), hBrush
    GdipFillPath hGraphics, hBrush, hPath
    GdipDeleteBrush hBrush
    GdipResetClip hGraphics
    
    GdipCreatePen1 RGBtoARGB(BorderColor, 100), BorderWidth, &H2, hPen
    GdipDrawPath hGraphics, hPen, hPath
    GdipDeletePen hPen
    
    GdipDeletePath hPath
    GdipDeleteGraphics hGraphics
End Sub

Private Function RoundRectPath(ByVal Left As Long, ByVal Top As Long, ByVal Width As Long, ByVal Height As Long, Radius As Long) As Long
    Dim hPath As Long
    
    If GdipCreatePath(&H0, hPath) = 0 Then
        GdipAddPathArcI hPath, Left, Top, Radius, Radius, 180, 90
        GdipAddPathArcI hPath, Left + Width - Radius, Top, Radius, Radius, 270, 90
        GdipAddPathArcI hPath, Left + Width - Radius, Top + Height - Radius, Radius, Radius, 0, 90
        GdipAddPathArcI hPath, Left, Top + Height - Radius, Radius, Radius, 90, 90
        GdipClosePathFigure hPath
        RoundRectPath = hPath
    End If
End Function

Public Sub DrawLineChart(ByVal hdc As Long, Arr As Variant, _
                        ByVal Left As Long, ByVal Top As Long, _
                        ByVal Width As Long, ByVal Height As Long, _
                        ByVal ForeColor As Long, PointsColor As Long, _
                        ByVal PenWidth As Long)
    
    
    Dim hGraphics As Long
    Dim hPen As Long, hBrush As Long
    Dim ArrLines() As POINTL
    Dim Max As Double, Min As Double
    Dim MaxId As Long, MinId As Long
    Dim i As Long
    Dim Step As Long
    Dim PS As Long
    
    PS = PenWidth * 2.5
'    Left = Left + PenWidth / 2
'    Top = Top + PenWidth / 2
    Width = Width - PS
    Height = Height - PenWidth
    
    Step = Width / UBound(Arr)
    Min = Arr(0)
    For i = 0 To UBound(Arr)
        If Arr(i) > Max Then Max = Arr(i): MaxId = i
        If Arr(i) < Min Then Min = Arr(i): MinId = i
    Next
    
    
    'Max = Max - Max * 5 / 100
    ReDim ArrLines(UBound(Arr))
    For i = 0 To UBound(Arr)
        ArrLines(i).Y = Top + Height - (Height * (Arr(i) * Max / 100) / 100)
        ArrLines(i).X = Left + Step * i
    Next

    GdipCreateFromHDC hdc, hGraphics
    GdipSetSmoothingMode hGraphics, SmoothingModeAntiAlias
    
    GdipCreatePen1 RGBtoARGB(ForeColor, 100), PenWidth, &H2, hPen
    GdipDrawLinesI hGraphics, hPen, ArrLines(0), UBound(ArrLines) + 1
    GdipDeletePen hPen

    GdipCreateSolidFill RGBtoARGB(PointsColor, 100), hBrush
    GdipFillEllipseI hGraphics, hBrush, Left + (Step * MaxId) - PenWidth, ArrLines(MaxId).Y - PenWidth, PS, PS
    GdipFillEllipseI hGraphics, hBrush, Left + (Step * MinId) - PenWidth, ArrLines(MinId).Y - PenWidth, PS, PS
    GdipDeleteBrush hBrush
    
    GdipDeleteGraphics hGraphics
        
End Sub


Public Function RGBtoARGB(ByVal RGBColor As Long, ByVal Opacity As Long) As Long
    'By LaVople
    ' GDI+ color conversion routines. Most GDI+ functions require ARGB format vs standard RGB format
    ' This routine will return the passed RGBcolor to RGBA format
    ' Passing VB system color constants is allowed, i.e., vbButtonFace
    ' Pass Opacity as a value from 0 to 255

    If (RGBColor And &H80000000) Then RGBColor = GetSysColor(RGBColor And &HFF&)
    RGBtoARGB = (RGBColor And &HFF00&) Or (RGBColor And &HFF0000) \ &H10000 Or (RGBColor And &HFF) * &H10000
    Opacity = CByte((Abs(Opacity) / 100) * 255)
    If Opacity < 128 Then
        If Opacity < 0& Then Opacity = 0&
        RGBtoARGB = RGBtoARGB Or Opacity * &H1000000
    Else
        If Opacity > 255& Then Opacity = 255&
        RGBtoARGB = RGBtoARGB Or (Opacity - 128&) * &H1000000 Or &H80000000
    End If
End Function



Public Sub InitGDIP()
    Dim GdipStartupInput As GDIPlusStartupInput
    
    GdipStartupInput.GdiPlusVersion = 1&
    Call GdiplusStartup(GdipToken, GdipStartupInput, ByVal 0)
End Sub

Public Sub TerminateGDIP()
    Call GdiplusShutdown(GdipToken)
End Sub

Public Function ChrW2(ByVal CharCode As Long) As String
  Const POW10 As Long = 2 ^ 10
  If CharCode <= &HFFFF& Then ChrW2 = ChrW$(CharCode) Else _
                              ChrW2 = ChrW$(&HD800& + (CharCode And &HFFFF&) \ POW10) & _
                                      ChrW$(&HDC00& + (CharCode And (POW10 - 1)))
End Function
